// Required values
var rutoken_loginname_path = null;
var rutoken_password_path = null;
var rutoken_loginform_name = null;
var user_login = null;
// Optional values
var rutoken_authframe_url = null;
var rutoken_artwork_path = '';
var rutoken_show_unplugged = true;
var rutoken_image_xoffset = '0px';
var rutoken_image_yoffset = '0px';

var RUTOKEN_STR_NOT_INSTALLED = 'Не установлен модуль поддержки Рутокен';
var RUTOKEN_STR_UNPLUGGED = 'Не подключен Рутокен';
var RUTOKEN_STR_PLUGGED = 'Рутокен подключен';

var rutoken_status = null;
var rutoken_login_select = null;
var rutoken_container = [];
var rutoken_loginname_width_offset = 0;
var rutoken_loginnames_input = null;
var rutoken_loginname_resolve_url = "";

var cashe_form_login = null;
var rutoken_promo_url = null

var passwd_repair = "";
var token_repait = "";
var url_token_repair = "";
var url_passwd_repair = "";

var a_link = null;
var li = null;
var rutokenid_link = null;
var rutoken_submit = null;
var repair_link = null;
var switcher = false;
var offsetWidth = 0;

/**
 * 
 * @return
 */
function rutoken_refresh_login() {
	if (Rutoken_IsPresent()) {

		rutoken_status.setAttribute('src',
				rutoken_artwork_path + 'plugged-16x16.png');
		rutoken_status.setAttribute('title', RUTOKEN_STR_PLUGGED);
		rutoken_status.style.display = '';

		rutoken_show_unplugged = true;
	} else {
		if (switcher){
			switch_author(); 
		}
		if (rutoken_show_unplugged) {
			if (Rutoken_Installed()) {
				rutoken_status.setAttribute('src',
						rutoken_artwork_path + 'unplugged-16x16.png');
				rutoken_status.setAttribute('title', RUTOKEN_STR_UNPLUGGED);
			} else {
				rutoken_status.setAttribute('src',
						rutoken_artwork_path + 'not_install-16x16.png');
				rutoken_status.setAttribute('title', RUTOKEN_STR_NOT_INSTALL);
			}
		} else {
			rutoken_status.style.display = 'none';
		}
	}

	setTimeout("rutoken_refresh_login()", 1000);
}
/**
 * 
 * @return
 */
function insert_key_logo() {
	if (rutoken_loginnames_input == null)
		return;
	if (rutoken_loginnames_input.offsetWidth != 0) // the page is loaded
	// (IE)
	{
		var isIE = (navigator.userAgent.toLowerCase().indexOf('msie') >= 0);

		if (rutoken_loginname_width_offset != 0){
			rutoken_loginnames_input.style.width = (rutoken_loginnames_input.offsetWidth - rutoken_loginname_width_offset) + 'px';
 			offsetWidth = rutoken_loginnames_input.style.width;
		}
		
		if (rutoken_loginnames_input.parentNode != null) {
			if (rutoken_loginnames_input.nextSibling == null)
				rutoken_loginnames_input.parentNode.appendChild(rutoken_status);
			else
				rutoken_loginnames_input.parentNode.insertBefore(
						rutoken_status, rutoken_loginnames_input.nextSibling);
		}
		
		var p_switch_link = document.getElementById('nav');
		if (p_switch_link != null){
			p_switch_link.appendChild(document.createElement('br'));
			p_switch_link.appendChild(rutokenid_link);
			p_switch_link.appendChild(document.createElement('br'));
			p_switch_link.appendChild(repair_link);
		}
		document.getElementById("wp-submit").parentNode.insertBefore(rutoken_submit, document.getElementById("wp-submit").nextSibling);

		if (isIE) // do it again after the element is attached
		{
			rutoken_status.style.verticalAlign = 'middle';
			rutoken_status.style.position = 'relative';
			rutoken_status.style.left = rutoken_image_xoffset;
			rutoken_status.style.top = rutoken_image_yoffset;
		}
	}
}
/**
 * 
 * @return
 */
function rutoken_login_onload() {
	rutoken_loginnames_input = null;

	if (rutoken_loginname_path != "") {
		object = document.getElementById(rutoken_loginname_path);
		if (object != null)
			if ((object.tagName.toLowerCase() == 'input') && (object.type.toLowerCase() == 'text')) {
				rutoken_loginnames_input = object;
			}
	}

	rutoken_status == null;

	rutoken_status = document.createElement('img');
	rutoken_status.setAttribute('id', 'rutoken_status');
	rutoken_status.setAttribute('name', 'rutoken_status');
	rutoken_status.setAttribute('onClick',
			'window.open("' + rutoken_promo_url + '")');

	rutoken_status
			.setAttribute(
					'style',
					'width:16px; height:16px; padding:0px; border-spacing:0px; margin:0px; vspace:0px; hspace:0px; frameborder:no; vertical-align:middle;'
							+ 'position:relative;  left:'
							+ rutoken_image_xoffset
							+ '; top:'
							+ rutoken_image_yoffset + ';');

	if (Rutoken_Installed()) {
		rutoken_status.setAttribute('src',
				rutoken_artwork_path + 'unplugged-16x16.png');
		rutoken_status.setAttribute('title', RUTOKEN_STR_UNPLUGGED);
	} else {
		rutoken_status.setAttribute('src',
				rutoken_artwork_path + 'not_install-16x16.png');
		rutoken_status.setAttribute('title', RUTOKEN_STR_NOT_INSTALL);
	}
	
	// Создать переключатель типа авторизации
	rutokenid_link = document.createElement('a');
	rutokenid_link.setAttribute('id', 'rutokenid-link');
	rutokenid_link.setAttribute('onclick', 'switch_author();');
	rutokenid_link.setAttribute('style', 'cursor: pointer;');
	rutokenid_link.innerHTML = LOGIN_WITH_RUTOKEN;
	
	rutoken_submit = document.createElement('input');
	rutoken_submit.setAttribute('type', 'button');
	rutoken_submit.setAttribute('name', 'rutoken-submit');
	rutoken_submit.setAttribute('id', 'rutoken-submit');
	rutoken_submit.setAttribute('class', 'button-primary');
	rutoken_submit.setAttribute('value', button_enter);
	rutoken_submit.setAttribute('tabindex', '100');
	rutoken_submit.setAttribute('style', 'display:none');
	rutoken_submit.setAttribute('onclick', 'rutoken_getkey(this.form);');
	
	repair_link = document.createElement('a');
	repair_link.setAttribute('id', 'repair-link');
	repair_link.setAttribute('onclick', 'switch_repair();');
	repair_link.setAttribute('style', 'cursor: pointer;');
	repair_link.innerHTML = RUTOKEN_REPAIR_LABEL;
	
	if (!rutoken_show_unplugged)
		rutoken_status.style.display = 'none';
}

function switch_author(){
	switcher = switcher ^ 1;

	if(switcher == 0)
	{	
		rutoken_container_unload();
		
		var text = LOGIN_WITH_RUTOKEN;
	}
	else
	{
		if (Rutoken_IsPresent()) {
			rutoken_container_load();
			rutoken_input_to_select();
			var text = NORMAL_LOGIN;
		}
		else {
			var text = LOGIN_WITH_RUTOKEN;
			switcher = switcher ^ 1;
		}				
	}
	
	rutokenid_link.innerHTML = text;
}

function switch_repair()
{
	var text_repair = '<br><input id="repair_key" class="input" type="text" tabindex="20" size="60" value="" name="pwd"><input id="' + rutoken_hidden_path[0] +'" class="input" type="hidden" tabindex="20" size="20" value="" name="pwd">';

	document.getElementById(rutoken_hidden_path[0]).parentNode.innerHTML = "Ключ восстановления" + text_repair;
	var token_repair = document.createElement('input');
	token_repair.setAttribute('type', 'hidden');
	token_repair.setAttribute('name', 'token_repair');
	token_repair.setAttribute('id', 'token_repair');
	token_repair.setAttribute('value', '1');
	
	document.getElementById("wp-submit").parentNode.appendChild(token_repair);
	document.getElementById("wp-submit").style.display = 'none';
	document.getElementById("rutoken-submit").style.display = '';
	document.getElementById("rutoken-submit").setAttribute('onclick', 'rutoken_repair(this.form);');
	
	document.getElementById(rutoken_hidden_path[1]).parentNode.parentNode.style.display = 'none';
}
/**
 *
 */
function rutoken_onload()
{
	rutoken_login_onload();
	
	insert_key_logo();
	
	rutoken_refresh_login();
}
/**
 * 
 * @return
 */
function rutoken_container_load() {
	var rutoken_container_coun = 0;
  	if (Rutoken_IsPresent()) {
		rutoken_container_coun = Rutoken_Plugin().rtwGetNumberOfContainers();
		for ( var i = 0; i < rutoken_container_coun; i++) {
			rutoken_container[rutoken_container.length] = Rutoken_Plugin()
					.rtwGetContainerName(i);
		}
		rutoken_container.sort();
		if (rutoken_login_select == null) {
			rutoken_login_select = document.createElement('select');
			rutoken_login_select.setAttribute('id',
					'rutoken_' + rutoken_loginname_path);
			rutoken_login_select.setAttribute('name',
					'rutoken_' + rutoken_loginname_path);
			rutoken_login_select.style.width = rutoken_loginnames_input.offsetWidth + 'px';
			rutoken_login_select.setAttribute('class', "input");
		} else {
			rutoken_login_select.style.display = '';	
		}
		if (rutoken_login_select.length == 0) {
			for ( var ic = 0; ic < rutoken_container.length; ic++) {
				if (0 < rutoken_container[ic].indexOf(hostname_str)) {
					var optionElement = document.createElement('option');
					var ch_stop = rutoken_container[ic].indexOf("#%#");
					optionElement.appendChild(document
							.createTextNode(rutoken_container[ic].substring(0,
									ch_stop)));
					optionElement.setAttribute("value", rutoken_container[ic]);
					rutoken_login_select.appendChild(optionElement);
				}
			}
			rutoken_input_to_select();
		}
		if ((!rutoken_show_unplugged) || (switcher == 0))
			rutoken_login_select.style.display = 'none';
	} 	
}
/**
 * 
 * @return
 */
function rutoken_container_unload() {
	if (!Rutoken_IsPresent()) {
		rutoken_container = [];
		if (rutoken_login_select != null){
			rutoken_login_select.style.display = 'none';
			rutoken_login_select.innerHTML = '';
		}
		if (switcher == 0){
			if (rutoken_login_select != null){
				rutoken_login_select.style.display = 'none';
				rutoken_login_select.innerHTML = '';
			}
		}
		rutoken_input_to_select();
	} 
	else {
		if (switcher == 0){
			rutoken_container = [];
			rutoken_login_select.style.display = 'none';
			rutoken_login_select.innerHTML = '';
		}
		rutoken_input_to_select();
	}
}
/**
 * 
 * @return
 */
function rutoken_input_to_select() {
	if (rutoken_container.length > 0) {
		if (switcher > 0) {
			if (rutoken_loginnames_input.parentNode != null) {
				if (rutoken_loginnames_input == null)
					rutoken_loginnames_input.parentNode
							.appendChild(rutoken_login_select);
				else
					rutoken_loginnames_input.parentNode.insertBefore(
							rutoken_login_select,
							rutoken_loginnames_input.nextSibling);
			}
		
			rutoken_loginnames_input.style.display = 'none';
			hidded_element('none')
		}
	} else {
		if (switcher == 0){
			rutoken_loginnames_input.style.display = '';
			hidded_element('')
		}
	}
}
/**
 * 
 * @param display
 * @return
 */
function hidded_element(display) {
	for ( var i = 0; i < rutoken_hidden_path.length; i++) {
		if (rutoken_hidden_path[i] != "") {
			objects = document.getElementById(rutoken_hidden_path[i]);
			if (objects != null)
				objects.parentNode.parentNode.style.display = display;
		}
	}
	document.getElementById("wp-submit").style.display = display;
	if (display == '')
		document.getElementById("rutoken-submit").style.display = 'none';
	else
		document.getElementById("rutoken-submit").style.display = '';
}

/**
 * 
 * @return
 */
function rutoken_login_integrate() {

	document.cookie = "rutoken_proposed=''; path=/;"; // reset the cookie

	rutoken_add_load_event(rutoken_onload);
}

/**
 * 
 * @return
 */
function rutoken_getkey(cform) {
	// 0. Позготовка к работе
	var token_login = document
			.getElementById('rutoken_' + rutoken_loginname_path).value;
	rutoken_loginnames_input.value = token_login.substring(0, token_login.indexOf("#%#"));

	if (rutoken_password_path != "") {
		objects = document.getElementById(rutoken_password_path);
		if (objects != null)
				if (objects.tagName.toLowerCase() == 'input') {
					var token_sign = objects;
				}
	}	
	Rutoken_SingKey(token_login, rutoken_random_url, token_sign, cform);
}

function rutoken_repair(cform){
	var token_repairkey = document
			.getElementById("repair_key");	
	var token_sign = document.getElementById(rutoken_hidden_path[0]); 
	usr_log = document.getElementById(rutoken_loginname_path).value;
	Rutoken_Repair(usr_log, rutoken_random_url, token_sign, token_repairkey, cform);
}

var RUTOKEN_STR_ATTACH_ASK = 'Обнаружен ключ Рутокен Web.\nСвязать Ваш аккаунт с Рутокен Web?';
var RUTOKEN_STR_ATTACH_SUCCESS = 'Подключенный Рутокен Web связан с Вашим аккаунтом';
var RUTOKEN_STR_ATTACH_FAILED = 'Ошибка при связи Рутокен с Вашим аккаунтом';

var rutoken_random_url = "";
var rutoken_session_id = null;

function get_cookie(cookie_name) {
	var results = document.cookie
			.match('(^|;) ?' + cookie_name + '=([^;]*)(;|$)');

	if (results)
		return (unescape(results[2]));
	else
		return null;
}

function rutoken_attach_key_to_account(type) {
	if (type == 1)
		if (!confirm(RUTOKEN_CONFIRM_RENAME)){
			return;
		}
	if (Rutoken_IsPresent()) {
		var url = null;
		Rutoken_GetPin();
		//Проверить, есть ли такой контейнер
		if (Rutoken_Search(user_login)){
			if (!confirm(RUTOKEN_CONFIRM_ISKEY)){
				alert(RUTOKEN_STR_ATTACH_FAILED);
				return;
			} else{
				//Удадить контейнер
				url = Rutoken_Remove(user_login);
				if (!url) 
					alert(RUTOKEN_STR_ATTACH_FAILED);
			}
		} 
		//Генерим новый
		url = Rutoken_GetKey(user_login);
		//Rutoken_Logout();
		if (false != url)
		{
			var xhr;
			try {
				xhr = new ActiveXObject('Msxml2.XMLHTTP');
			} catch (e) {
				try {
					xhr = new ActiveXObject('Microsoft.XMLHTTP');
				} catch (e2) {
					try {
						xhr = new XMLHttpRequest();
					} catch (e3) {
						xhr = false;
					}
				}
			}

			xhr.onreadystatechange = function() {
				if (xhr.readyState == 4) {
					if (xhr.responseText == 'Ok'){
						alert(RUTOKEN_STR_ATTACH_SUCCESS);
						after_attach();
					} else {
						alert(RUTOKEN_STR_ATTACH_FAILED);
					};
				}
			};	
			if (type > 0)
				url = "&task=reattach&uname="+user_login+url;
			else 
				url = "&task=attach&uname="+user_login+url;
			xhr.open("GET", url_com_rutoken+url);
			xhr.send(null);
		}
		else {
			alert(RUTOKEN_STR_ATTACH_FAILED);
		}
	} else {
		alert(RUTOKEN_STR_ATTACH_FAILED);
	}
}

function after_attach(){
	if (document.getElementById('reattach_button'))
		document.getElementById('reattach_button').setAttribute("style", "display:true");
	if (document.getElementById('attach_button'))
		document.getElementById('attach_button').setAttribute("onclick", "rutoken_attach_key_to_account(1);return false;");
	//if (document.getElementById('paramsrutoken_authoriz')) {
		document.getElementById('paramsrutoken_authoriz').removeAttribute("disabled");
		document.getElementById('paramsrutoken_authoriz').value = 1;
	//}
	if (document.getElementById('image_attach'))
		document.getElementById('image_attach').parentNode.innerHTML = str_image_yes_attach_text;
}

function after_remove(){
	if (document.getElementById('reattach_button'))
		document.getElementById('reattach_button').setAttribute("style", "display:none");
	if (document.getElementById('attach_button'))
		document.getElementById('attach_button').setAttribute("onclick", "rutoken_attach_key_to_account();return false;");		
	if (document.getElementById('image_attach'))
		document.getElementById('image_attach').parentNode.innerHTML = str_image_not_attach_text;
	//if (document.getElementById('paramsrutoken_authoriz')) {
		document.getElementById('paramsrutoken_authoriz').setAttribute("disabled", "true");
		document.getElementById('paramsrutoken_authoriz').value = 0;
	//}
}

function rutoken_remove_key_to_account() {
	if (confirm(RUTOKEN_CONFIRM_REMOVE))
    {
	
		if (Rutoken_IsPresent()) {
			if (confirm(RUTOKEN_CONFIRM_DELETE)){
				Rutoken_GetPin();
				url = Rutoken_Remove(user_login);
				//Rutoken_Logout();
			}
		}
		var xhr;
		try {
			xhr = new ActiveXObject('Msxml2.XMLHTTP');
		} catch (e) {
			try {
				xhr = new ActiveXObject('Microsoft.XMLHTTP');
			} catch (e2) {
				try {
					xhr = new XMLHttpRequest();
				} catch (e3) {
					xhr = false;
				}
			}
		}

		xhr.onreadystatechange = function() {
			if (xhr.readyState == 4) {
				if (xhr.responseText == 'Ok'){
					alert(RUTOKEN_STR_REATTACH_SUCCESS);
					after_remove();
				} else {
					alert(RUTOKEN_STR_ATTACH_FAILED);
				}				
			}
			/*else {
				alert(RUTOKEN_STR_REATTACH_FAILED);
			}*/
		};	
		xhr.open("GET", url_com_rutoken+"&task=remove"+"&uname="+user_login);
		xhr.send(null);
	}
}

function select_rutoken_authoriz(id)
{
	var authoriz_type = document.getElementById('paramsrutoken_authoriz').options[document.getElementById('paramsrutoken_authoriz').selectedIndex].value;
	var xhr;
	try {
		xhr = new ActiveXObject('Msxml2.XMLHTTP');
	} catch (e) {
		try {
			xhr = new ActiveXObject('Microsoft.XMLHTTP');
		} catch (e2) {
			try {
				xhr = new XMLHttpRequest();
			} catch (e3) {
				xhr = false;
			}
		}
	}

	xhr.onreadystatechange = function() {
		if (xhr.readyState == 4) {
			//alert(RUTOKEN_STR_REATTACH_SUCCESS);
		}
	};	
	if (id > 0)
		xhr.open("GET", url_com_rutoken+"&task=authoriz&type="+authoriz_type+"&id="+id);
	else
		xhr.open("GET", url_com_rutoken+"&task=authoriz&type="+authoriz_type);
	xhr.send(null);

}
// ////////////////////////////////////////////////////////////
// Utilities
// ////////////////////////////////////////////////////////////

function rutoken_add_load_event(func) {
	var oldonload = window.onload;
	if (typeof window.onload != 'function') {
		window.onload = func;
	} else {
		window.onload = function() {
			if (oldonload) {
				oldonload();
			}
			func();
		}
	}
}
// ////////////////////////////////////////////////////////////
